Merge branch 'jc/stash-create'
[git/git.git] / git-merge.sh
CommitLineData
91063bbc
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5
d66424c4 6USAGE='[-n] [--summary] [--[no-]commit] [--[no-]squash] [--[no-]ff] [-s <strategy>] [-m=<merge-message>] <commit>+'
17bcdad3 7
533b7039 8SUBDIRECTORY_OK=Yes
ae2b0f15 9. git-sh-setup
7eff28a9 10require_work_tree
533b7039 11cd_to_toplevel
91063bbc 12
d1014a17 13test -z "$(git ls-files -u)" ||
533b7039 14 die "You are in the middle of a conflicted merge."
d1014a17 15
91063bbc
JH
16LF='
17'
18
68faf689 19all_strategies='recur recursive octopus resolve stupid ours subtree'
a06f678e 20default_twohead_strategies='recursive'
6ea23343 21default_octopus_strategies='octopus'
a0050852
JH
22no_fast_forward_strategies='subtree ours'
23no_trivial_strategies='recursive recur subtree ours'
91063bbc 24use_strategies=
6ea23343 25
a0050852
JH
26allow_fast_forward=t
27allow_trivial_merge=t
91063bbc 28
a9358240 29dropsave() {
deca7e8c 30 rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
a64d7784 31 "$GIT_DIR/MERGE_STASH" || exit 1
a9358240
JH
32}
33
34savestate() {
60fa0560 35 # Stash away any local modifications.
a64d7784 36 git stash create >"$GIT_DIR/MERGE_STASH"
a9358240
JH
37}
38
39restorestate() {
a64d7784 40 if test -f "$GIT_DIR/MERGE_STASH"
deca7e8c 41 then
228e2eb6 42 git reset --hard $head >/dev/null
a64d7784 43 git stash apply $(cat "$GIT_DIR/MERGE_STASH")
5be60078 44 git update-index --refresh >/dev/null
deca7e8c 45 fi
91063bbc
JH
46}
47
7d0c6887
JH
48finish_up_to_date () {
49 case "$squash" in
50 t)
51 echo "$1 (nothing to squash)" ;;
52 '')
53 echo "$1" ;;
54 esac
55 dropsave
56}
57
58squash_message () {
59 echo Squashed commit of the following:
60 echo
2ae4fd76 61 git log --no-merges ^"$head" $remoteheads
7d0c6887
JH
62}
63
4f692b19 64finish () {
e1447e38
SP
65 if test '' = "$2"
66 then
f9474132 67 rlogm="$GIT_REFLOG_ACTION"
e1447e38
SP
68 else
69 echo "$2"
f9474132 70 rlogm="$GIT_REFLOG_ACTION: $2"
e1447e38 71 fi
7d0c6887
JH
72 case "$squash" in
73 t)
74 echo "Squash commit -- not updating HEAD"
75 squash_message >"$GIT_DIR/SQUASH_MSG"
4f692b19 76 ;;
7d0c6887
JH
77 '')
78 case "$merge_msg" in
79 '')
80 echo "No merge message -- not updating HEAD"
81 ;;
82 *)
5be60078 83 git update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
d4bb43ee 84 git gc --auto
7d0c6887
JH
85 ;;
86 esac
4f692b19
JH
87 ;;
88 esac
7d0c6887 89 case "$1" in
91063bbc 90 '')
7d0c6887
JH
91 ;;
92 ?*)
51e7ecf4
AR
93 if test "$show_diffstat" = t
94 then
fefe49d1 95 # We want color (if set), but no pager
5be60078 96 GIT_PAGER='' git diff --stat --summary -M "$head" "$1"
51e7ecf4 97 fi
91063bbc
JH
98 ;;
99 esac
46232915
JE
100
101 # Run a post-merge hook
102 if test -x "$GIT_DIR"/hooks/post-merge
103 then
104 case "$squash" in
105 t)
106 "$GIT_DIR"/hooks/post-merge 1
107 ;;
108 '')
109 "$GIT_DIR"/hooks/post-merge 0
110 ;;
111 esac
112 fi
91063bbc
JH
113}
114
b1bfcae4
JH
115merge_name () {
116 remote="$1"
5be60078
JH
117 rh=$(git rev-parse --verify "$remote^0" 2>/dev/null) || return
118 bh=$(git show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
b1bfcae4
JH
119 if test "$rh" = "$bh"
120 then
121 echo "$rh branch '$remote' of ."
122 elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
5be60078 123 git show-ref -q --verify "refs/heads/$truname" 2>/dev/null
b1bfcae4
JH
124 then
125 echo "$rh branch '$truname' (early part) of ."
85295a52
MT
126 elif test "$remote" = "FETCH_HEAD" -a -r "$GIT_DIR/FETCH_HEAD"
127 then
128 sed -e 's/ not-for-merge / /' -e 1q \
129 "$GIT_DIR/FETCH_HEAD"
b1bfcae4
JH
130 else
131 echo "$rh commit '$remote'"
132 fi
133}
134
d38eb710 135parse_option () {
91063bbc
JH
136 case "$1" in
137 -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
138 --no-summa|--no-summar|--no-summary)
51e7ecf4
AR
139 show_diffstat=false ;;
140 --summary)
141 show_diffstat=t ;;
7d0c6887 142 --sq|--squ|--squa|--squas|--squash)
d66424c4 143 allow_fast_forward=t squash=t no_commit=t ;;
d08af0ad 144 --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
d66424c4 145 allow_fast_forward=t squash= no_commit= ;;
d08af0ad 146 --c|--co|--com|--comm|--commi|--commit)
d66424c4 147 allow_fast_forward=t squash= no_commit= ;;
123ee3ca 148 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
d66424c4
LH
149 allow_fast_forward=t squash= no_commit=t ;;
150 --ff)
151 allow_fast_forward=t squash= no_commit= ;;
152 --no-ff)
153 allow_fast_forward=false squash= no_commit= ;;
91063bbc
JH
154 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
155 --strateg=*|--strategy=*|\
156 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
157 case "$#,$1" in
158 *,*=*)
8096fae7 159 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
f88ed172 160 1,*)
91063bbc
JH
161 usage ;;
162 *)
163 strategy="$2"
164 shift ;;
165 esac
166 case " $all_strategies " in
167 *" $strategy "*)
168 use_strategies="$use_strategies$strategy " ;;
169 *)
170 die "available strategies are: $all_strategies" ;;
171 esac
172 ;;
17bcdad3
JH
173 -m=*|--m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
174 merge_msg=`expr "z$1" : 'z-[^=]*=\(.*\)'`
175 have_message=t
176 ;;
177 -m|--m|--me|--mes|--mess|--messa|--messag|--message)
178 shift
179 case "$#" in
180 1) usage ;;
181 esac
182 merge_msg="$1"
183 have_message=t
184 ;;
91063bbc 185 -*) usage ;;
d38eb710 186 *) return 1 ;;
91063bbc
JH
187 esac
188 shift
d38eb710
LH
189 args_left=$#
190}
191
aec7b362
LH
192parse_config () {
193 while test $# -gt 0
194 do
195 parse_option "$@" || usage
196 while test $args_left -lt $#
197 do
198 shift
199 done
200 done
201}
202
d38eb710
LH
203test $# != 0 || usage
204
205have_message=
aec7b362
LH
206
207if branch=$(git-symbolic-ref -q HEAD)
208then
209 mergeopts=$(git config "branch.${branch#refs/heads/}.mergeoptions")
210 if test -n "$mergeopts"
211 then
212 parse_config $mergeopts
213 fi
214fi
215
d38eb710
LH
216while parse_option "$@"
217do
218 while test $args_left -lt $#
219 do
220 shift
221 done
91063bbc
JH
222done
223
51e7ecf4 224if test -z "$show_diffstat"; then
5be60078 225 test "$(git config --bool merge.diffstat)" = false && show_diffstat=false
51e7ecf4
AR
226 test -z "$show_diffstat" && show_diffstat=t
227fi
228
17bcdad3
JH
229# This could be traditional "merge <msg> HEAD <commit>..." and the
230# way we can tell it is to see if the second token is HEAD, but some
231# people might have misused the interface and used a committish that
232# is the same as HEAD there instead. Traditional format never would
233# have "-m" so it is an additional safety measure to check for it.
234
235if test -z "$have_message" &&
5be60078
JH
236 second_token=$(git rev-parse --verify "$2^0" 2>/dev/null) &&
237 head_commit=$(git rev-parse --verify "HEAD" 2>/dev/null) &&
17bcdad3
JH
238 test "$second_token" = "$head_commit"
239then
240 merge_msg="$1"
241 shift
242 head_arg="$1"
243 shift
5be60078 244elif ! git rev-parse --verify HEAD >/dev/null 2>&1
8092c7f6
JH
245then
246 # If the merged head is a valid one there is no reason to
247 # forbid "git merge" into a branch yet to be born. We do
248 # the same for "git pull".
249 if test 1 -ne $#
250 then
251 echo >&2 "Can merge only exactly one commit into empty head"
252 exit 1
253 fi
254
255 rh=$(git rev-parse --verify "$1^0") ||
256 die "$1 - not something we can merge"
257
5be60078
JH
258 git update-ref -m "initial pull" HEAD "$rh" "" &&
259 git read-tree --reset -u HEAD
8092c7f6
JH
260 exit
261
17bcdad3
JH
262else
263 # We are invoked directly as the first-class UI.
264 head_arg=HEAD
265
266 # All the rest are the commits being merged; prepare
267 # the standard merge summary message to be appended to
268 # the given message. If remote is invalid we will die
269 # later in the common codepath so we discard the error
270 # in this loop.
271 merge_name=$(for remote
272 do
b1bfcae4 273 merge_name "$remote"
5be60078 274 done | git fmt-merge-msg
17bcdad3
JH
275 )
276 merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
277fi
5be60078 278head=$(git rev-parse --verify "$head_arg"^0) || usage
91063bbc
JH
279
280# All the rest are remote heads
6ea23343 281test "$#" = 0 && usage ;# we need at least one remote head.
7f9acb2a 282set_reflog_action "merge $*"
6ea23343 283
9954f5b8 284remoteheads=
91063bbc
JH
285for remote
286do
5be60078 287 remotehead=$(git rev-parse --verify "$remote"^0 2>/dev/null) ||
91063bbc 288 die "$remote - not something we can merge"
9954f5b8 289 remoteheads="${remoteheads}$remotehead "
e0ec1819
SP
290 eval GITHEAD_$remotehead='"$remote"'
291 export GITHEAD_$remotehead
91063bbc 292done
9954f5b8 293set x $remoteheads ; shift
91063bbc 294
6ea23343
JH
295case "$use_strategies" in
296'')
297 case "$#" in
298 1)
5be60078 299 var="`git config --get pull.twohead`"
de811948
SP
300 if test -n "$var"
301 then
302 use_strategies="$var"
303 else
304 use_strategies="$default_twohead_strategies"
305 fi ;;
6ea23343 306 *)
5be60078 307 var="`git config --get pull.octopus`"
de811948
SP
308 if test -n "$var"
309 then
310 use_strategies="$var"
311 else
312 use_strategies="$default_octopus_strategies"
313 fi ;;
6ea23343
JH
314 esac
315 ;;
316esac
317
318for s in $use_strategies
319do
a0050852 320 for ss in $no_fast_forward_strategies
de6f0def
JH
321 do
322 case " $s " in
a0050852
JH
323 *" $ss "*)
324 allow_fast_forward=f
325 break
326 ;;
327 esac
328 done
329 for ss in $no_trivial_strategies
330 do
331 case " $s " in
332 *" $ss "*)
333 allow_trivial_merge=f
de6f0def
JH
334 break
335 ;;
336 esac
337 done
6ea23343
JH
338done
339
13956670
JH
340case "$#" in
3411)
5be60078 342 common=$(git merge-base --all $head "$@")
13956670
JH
343 ;;
344*)
5be60078 345 common=$(git show-branch --merge-base $head "$@")
13956670
JH
346 ;;
347esac
91063bbc
JH
348echo "$head" >"$GIT_DIR/ORIG_HEAD"
349
a0050852 350case "$allow_fast_forward,$#,$common,$no_commit" in
6ea23343 351?,*,'',*)
88f8f0a5 352 # No common ancestors found. We need a real merge.
91063bbc 353 ;;
6ea23343 354?,1,"$1",*)
91063bbc 355 # If head can reach all the merge then we are up to date.
6ea23343 356 # but first the most common case of merging one remote.
7d0c6887 357 finish_up_to_date "Already up-to-date."
91063bbc
JH
358 exit 0
359 ;;
a0050852 360t,1,"$head",*)
91063bbc 361 # Again the most common case of merging one remote.
5be60078
JH
362 echo "Updating $(git rev-parse --short $head)..$(git rev-parse --short $1)"
363 git update-index --refresh 2>/dev/null
be242d57
BF
364 msg="Fast forward"
365 if test -n "$have_message"
366 then
367 msg="$msg (no commit created; -m option ignored)"
368 fi
5be60078
JH
369 new_head=$(git rev-parse --verify "$1^0") &&
370 git read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
be242d57 371 finish "$new_head" "$msg" || exit
a9358240 372 dropsave
91063bbc
JH
373 exit 0
374 ;;
6ea23343 375?,1,?*"$LF"?*,*)
91063bbc
JH
376 # We are not doing octopus and not fast forward. Need a
377 # real merge.
378 ;;
6ea23343 379?,1,*,)
f9d72413 380 # We are not doing octopus, not fast forward, and have only
c82d7117 381 # one common.
5be60078 382 git update-index --refresh 2>/dev/null
a0050852
JH
383 case "$allow_trivial_merge" in
384 t)
c82d7117
SP
385 # See if it is really trivial.
386 git var GIT_COMMITTER_IDENT >/dev/null || exit
387 echo "Trying really trivial in-index merge..."
5be60078
JH
388 if git read-tree --trivial -m -u -v $common $head "$1" &&
389 result_tree=$(git write-tree)
c82d7117
SP
390 then
391 echo "Wonderful."
392 result_commit=$(
a23bfaed 393 printf '%s\n' "$merge_msg" |
5be60078 394 git commit-tree $result_tree -p HEAD -p "$1"
c82d7117
SP
395 ) || exit
396 finish "$result_commit" "In-index merge"
397 dropsave
398 exit 0
399 fi
400 echo "Nope."
401 esac
f9d72413 402 ;;
91063bbc
JH
403*)
404 # An octopus. If we can reach all the remote we are up to date.
405 up_to_date=t
406 for remote
407 do
5be60078 408 common_one=$(git merge-base --all $head $remote)
91063bbc
JH
409 if test "$common_one" != "$remote"
410 then
411 up_to_date=f
412 break
413 fi
414 done
415 if test "$up_to_date" = t
416 then
7d0c6887 417 finish_up_to_date "Already up-to-date. Yeeah!"
91063bbc
JH
418 exit 0
419 fi
420 ;;
421esac
422
e3b59a44
JH
423# We are going to make a new commit.
424git var GIT_COMMITTER_IDENT >/dev/null || exit
425
a9358240
JH
426# At this point, we need a real merge. No matter what strategy
427# we use, it would operate on the index, possibly affecting the
428# working tree, and when resolved cleanly, have the desired tree
429# in the index -- this means that the index must be in sync with
60fa0560 430# the $head commit. The strategies are responsible to ensure this.
91063bbc 431
a9358240
JH
432case "$use_strategies" in
433?*' '?*)
434 # Stash away the local changes so that we can try more than one.
435 savestate
436 single_strategy=no
437 ;;
438*)
a64d7784 439 rm -f "$GIT_DIR/MERGE_STASH"
a9358240
JH
440 single_strategy=yes
441 ;;
442esac
91063bbc
JH
443
444result_tree= best_cnt=-1 best_strategy= wt_strategy=
695bf722 445merge_was_ok=
91063bbc
JH
446for strategy in $use_strategies
447do
448 test "$wt_strategy" = '' || {
449 echo "Rewinding the tree to pristine..."
a9358240 450 restorestate
91063bbc 451 }
a9358240
JH
452 case "$single_strategy" in
453 no)
454 echo "Trying merge strategy $strategy..."
455 ;;
456 esac
457
458 # Remember which strategy left the state in the working tree
91063bbc 459 wt_strategy=$strategy
a9358240 460
123ee3ca
JH
461 git-merge-$strategy $common -- "$head_arg" "$@"
462 exit=$?
463 if test "$no_commit" = t && test "$exit" = 0
464 then
695bf722 465 merge_was_ok=t
123ee3ca
JH
466 exit=1 ;# pretend it left conflicts.
467 fi
468
469 test "$exit" = 0 || {
91063bbc
JH
470
471 # The backend exits with 1 when conflicts are left to be resolved,
472 # with 2 when it does not handle the given merge at all.
473
91063bbc
JH
474 if test "$exit" -eq 1
475 then
476 cnt=`{
5be60078
JH
477 git diff-files --name-only
478 git ls-files --unmerged
91063bbc
JH
479 } | wc -l`
480 if test $best_cnt -le 0 -o $cnt -le $best_cnt
481 then
482 best_strategy=$strategy
483 best_cnt=$cnt
484 fi
485 fi
486 continue
487 }
488
489 # Automerge succeeded.
5be60078 490 result_tree=$(git write-tree) && break
91063bbc
JH
491done
492
493# If we have a resulting tree, that means the strategy module
494# auto resolved the merge cleanly.
495if test '' != "$result_tree"
496then
d66424c4
LH
497 if test "$allow_fast_forward" = "t"
498 then
499 parents=$(git show-branch --independent "$head" "$@")
500 else
501 parents=$(git rev-parse "$head" "$@")
502 fi
503 parents=$(echo "$parents" | sed -e 's/^/-p /')
5be60078 504 result_commit=$(printf '%s\n' "$merge_msg" | git commit-tree $result_tree $parents) || exit
e1447e38 505 finish "$result_commit" "Merge made by $wt_strategy."
a9358240 506 dropsave
91063bbc
JH
507 exit 0
508fi
509
510# Pick the result from the best strategy and have the user fix it up.
511case "$best_strategy" in
512'')
a9358240 513 restorestate
0c4e95d0
JH
514 case "$use_strategies" in
515 ?*' '?*)
516 echo >&2 "No merge strategy handled the merge."
517 ;;
518 *)
519 echo >&2 "Merge with strategy $use_strategies failed."
520 ;;
521 esac
4275df51 522 exit 2
91063bbc
JH
523 ;;
524"$wt_strategy")
525 # We already have its result in the working tree.
526 ;;
527*)
528 echo "Rewinding the tree to pristine..."
a9358240 529 restorestate
91063bbc 530 echo "Using the $best_strategy to prepare resolving by hand."
a9358240 531 git-merge-$best_strategy $common -- "$head_arg" "$@"
91063bbc
JH
532 ;;
533esac
7d0c6887
JH
534
535if test "$squash" = t
536then
537 finish
538else
539 for remote
540 do
541 echo $remote
542 done >"$GIT_DIR/MERGE_HEAD"
a23bfaed 543 printf '%s\n' "$merge_msg" >"$GIT_DIR/MERGE_MSG"
7d0c6887 544fi
deca7e8c 545
695bf722
JH
546if test "$merge_was_ok" = t
547then
548 echo >&2 \
549 "Automatic merge went well; stopped before committing as requested"
550 exit 0
551else
6b94f1e4
JH
552 {
553 echo '
554Conflicts:
555'
556 git ls-files --unmerged |
557 sed -e 's/^[^ ]* / /' |
558 uniq
559 } >>"$GIT_DIR/MERGE_MSG"
b4372ef1 560 git rerere
50ac7408 561 die "Automatic merge failed; fix conflicts and then commit the result."
695bf722 562fi